#!/usr/local/bin/perl5

use SHTML;

open(D,"<" . $ARGV[0]) 
    || die "Couldn't open $ARGV[0], $!";
{
    local $/;
    $_ = <D>;
}
close(D) || die "Couldn't close $ARGV[0], $!";

$_ = striptohtml($_);
my ($fieldref,$inform) = (0,0);
my (@forminfo,%fieldlist,@fieldlist);

for my $line (split(/\n/))
{
    if ($line =~ /<form/i)
    {
        $inform=1;
        next;
    }
    elsif ($inform)
    {
        if (($line =~ /<input.*/i) || ($line =~ /<textarea.*/i))
        {
            for my $element (split / /,$line)
            {
                $element =~ s/[<>\"]//g;
                my ($formfield,$vinfo) = split /=/,$element;
                $formfield = lc($formfield);

                if ($formfield =~ /textarea/i)
                {
                    $fieldlist{type} = 1;
                    $forminfo[$fieldref]{type} = $formfield;
                }
                else
                {
                    $fieldlist{$formfield} = 1;
                    $forminfo[$fieldref]{$formfield} = $vinfo;
                }
            }
            $fieldref++;
        }
    }
}

push @fieldlist,'name',grep(!/name/,sort keys %fieldlist);

foreach $_ (@fieldlist)
{
    printf("%-8s",lc($_));
}
print "\n";
for($fieldref=0;$fieldref<@forminfo;$fieldref++)
{
    foreach $_ (@fieldlist)
    {
        printf("%-8s",defined($forminfo[$fieldref]{lc($_)}) ? 
               "$forminfo[$fieldref]{lc($_)}" : '');
    }
    print "\n";
}
