#/usr/bin/perl

#Ce programme prend en argument un repertoire, le parcourt rcursivement 
#et fait une action sur certains fichiers rencontrs dans ce parcours d'arbre
# Exemple d'appel : perl parcoursRepertoire.pl monrepertoire/

my $filecount=0;
my $dirname=$ARGV[0];
$dirname=$dirname."\/" unless ($dirname=~/\/$/);
print "DIRNAME : ",$dirname,"\n";
Show_Dir($dirname);

open(TRACE,">listeFichierNettoyes.txt");
close(TRACE);

sub Show_Dir {
    open(TRACE,">>listeFichierNettoyes.txt") or die "can't open TRACE $!\n";
    my $path = shift(@_);
    $path=$path."\/" unless ($path=~/\/$/);
    print "DIRNAME : ",$path,"\n";
    opendir(DIR, $path) or die "can't open $path: $!\n";
    my @files = readdir(DIR);
    closedir(DIR);
    foreach my $file (@files) {
	$filecount++;
	next if $file =~ /^\.\.?$/;
	$file = $path.$file;
	print "F => ",$file,"\n";
	if (-d $file) {
	    close(TRACE);
	    Show_Dir($file);	#appel recursif
	}
	elsif (-f $file) {
	    if (($file=~/\.htm/)) {
		my $newfile = $file;
		$newfile=~s/\.htm.*/\.xml/;
		print "N=> ",$newfile,"\n";
		print "FILE$filecount = $file\n";
		print TRACE "FILE$filecount = $file cleanTidy done \n";
		print "tidy -config config-xml.txt $file > $newfile\n";
		$file=~s/\//\\/g;
		$newfile=~s/\//\\/g;
		system("tidy -config config-xml.txt $file > $newfile");
	    }
	}
	else {
	    print TRACE "FILE$filecount = $file cleanTidy skipped \n";
	}
	
    }
    close(TRACE);
}


