#!/usr/bin/perl

# FIX2HTML

# Mise en page au format HTML des rsultats de WEBFIX

# Copyright Ludovic Tanguy - ERSS (C) 2001 
# Ludovic.Tanguy@univ-tlse2.fr

#  Ce programme est un logiciel libre ; vous pouvez le redistribuer
#  et/ou le modifier conformment aux dispositions de la Licence
#  Publique Gnrale GNU, telle que publie par la Free Software
#  Foundation ; version 2 de la licence, ou encore toute version
#  ultrieure.

#  Ce programme est distribu dans l'espoir qu'il sera utile, mais
#  SANS AUCUNE GARANTIE ; sans mme la garantie implicite de
#  COMMERCIALISATION ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus
#  de dtail, voir la Licence Publique Gnrale GNU .

#  Vous devez avoir reu un exemplaire de la Licence Publique Gnrale
#  GNU en mme temps que ce programme ; si ce n'est pas le cas,
#  crivez  la Free Software Foundation Inc., 675 Mass Ave,
#  Cambridge, MA 02139, Etats-Unis.


use locale;


while(<>){
    chomp;
    if (m/^PREFIXE :/){
	print "<h2>",$_,"</h2><p>\n";}
    elsif (m/ATTESTATIONS :/){
	print "<h5>",$_,"</h5><p>\n";}
    elsif (m/PATRON :/){
	print "<b>",$_,"</b><p>\n";}
    else {
	@t=split(/\t/, $_);
	print "<FONT COLOR=\"RED\">",$t[0], "   </FONT><a href=\"",$t[1],"\">",$t[1],"</a><p>\n"
	}
}



# FIX2HTML.PL ends here
