package TagText;

use strict;

sub new
{
    my $self = shift;
    my $class = ref($self) || $self;
    my $text = shift;

    my @locs;

    return bless {text => $text,
                  loc => \@locs,}, $class;
}

sub start_element
{
    my ($self, $info) = @_;

    push @{$self->{loc}},$info->{Name};
}

sub end_element
{
    my ($self, $info) = @_;

    pop @{$self->{loc}};
}    

sub characters
{
    my ($self, $info) = @_;

    if ($info->{Data} =~ m/$self->{text}/i)
    {
	if (!open(TRACE, ">>MKC-tmp_tagtextsearch.txt")) {
	    &mkPrintErreur("ERREUR : Impossible d\'ouvrir le fichier tagtextsearch.txt : \n");
	    return;
	}
	print TRACE "Matched [$info->{Data}] in [", join(' -> ', @{$self->{loc}}),"]\n";
	close(TRACE);
    }
}

1;
