#!/usr/local/bin/perl5

my @months = qw (JUNK Jan Feb Mar Apr May 
                 Jun Jul Aug Sep Oct Nov Dec );
my $logdir = '/usr/local/etc/wwwlogs';

print <<EOF;
<html>
<head>
<title>WWW Server Logs</title>
</head>
<body>
<font size=+2><b>WWW Server Logs</b></font>
<dl>
EOF

chdir("$logdir");
for my $dir (grep (/^[a-zA-Z0-9]/,glob("*")))
{
    print "<dt>$dir\n";
    chdir("$logdir/$dir");
    for my $server (grep(/^[a-zA-Z0-9]/,glob("*")))
    {
        chdir("$logdir/$dir/$server");
	print "<dl><dt>$server\n";
	for my $date (grep (/^[a-zA-Z0-9]/,
                            glob("*")))
	{
	    my ($dateonly) = (split (/\./,$date))[0];
	    my $mon = substr($dateonly, 5, 2);
	    my $year = substr($dateonly, 0, 4);
	    print("<dd><a href=\"/wwwlogs/$dir/$server/$date\">",
                  " $months[$mon] $year</a>\n");
	}
	print "</dl>\n";
    }
}
print "</dl>\n</body>\n";
